/****************************************************************************************
 *                                                                                      *
 * Copyright (C) 2007 Ikanos Communications Inc. All rights reserved                    *
 *                                                                                      *
 * The  information  and  source  code contained  herein  is the  exclusive  property   *
 * of Ikanos Communications and may not be disclosed, examined or reproduced in whole   *
 * or in part without  the explicit written authorization from Ikanos Communications.   *
 *                                                                                      *
 ****************************************************************************************/

/****************************************************************************************
 *                                                                                      *
 * File name    : apegressport.h                                                        *
 * Author       : Ikanos Communications  [ jpattar@ikanos.com ]                         *
 * Version      :                                                                       *
 * Date         : 08th Oct 2009                                                         *
 * Description  : This file contains apegress list. 					*
 *                                                                                      *
 ****************************************************************************************/

#ifndef _APEGRESSPORT_H_
#define _APEGRESSPORT_H_


typedef struct	apEgressPort_s
{
    void        *pEgress;       // Physical address of egress port input queue
    void        *pFlowID;       // Flow ID. Only significant to egress port
} apEgressPort_t;

/* offset macros */
#define EGRESS_PORT_TYPE_OFFSET_IN_FLOWID	30

/*************************************
 * pFlowID  bit fields for Ethernet AP
 *      Bit 0 - 2       Priority
 *      Bit 3 - 14      VLAN ID for Multicast packets
 *      Bit 15          Tag/no-Tag for Multicast Vlan packets
 *      Bit 16 - 18     pktQosPriority
 *      Bit 19 - 29     MTU size
 *      Bit 30 -        reserved
 *      Bit 31 -    used for as AP_MCAST_SMAC_MOD_FLOWID_BIT
 *
 * pFlowID bit fields for ATM AP
 *      Bit 0 - 4       Atm encapsulations types defined in atmhost.h
 *      Bit 5 - 14      PVC connection Identifier ( received from ATM AP
 *                      while configuring VCC )
 *      Bit 14- 16      Priority
 *      Bit 17- 28      VLAN ID for Multicast packets
 *      Bit 29          Tag/no-Tag for Multicast Vlan packets
 *      Bit 30          reserved
 *      Bit 31          1 if SMAC has to change with AP Mac
 *************************************/

#endif /* _APEGRESSPORT_H_ */
