/****************************************************************************************
 *                                                                                      *
 * Copyright (C) 2007 Ikanos Communications Inc. All rights reserved                    *
 *                                                                                      *
 * The  information  and  source  code contained  herein  is the  exclusive  property   *
 * of Ikanos Communications and may not be disclosed, examined or reproduced in whole   *
 * or in  part without  the explicit written authorization from Ikanos Communications   *
 *                                                                                      *
 ****************************************************************************************/

/****************************************************************************************
 *                                                                                      *
 * File name    : apstatistics.h	                                                *
 * Author       : Jagannath Pattar      [ jpattar@ikanos.com ]                          *
 * Version      :                                                                       *
 * Date         : 29th June 2009                                                        *
 * Description  : This header file contains required data structure for all fastpath    *
 *                statistics. Each RFT/BFT/PFT maitains this structure.			*
 *                                                                                      *
 ****************************************************************************************/


/*--------------------------------------INCLUDES----------------------------------------*/
#ifndef _APSTATISTICSDEFS_H_
#define _APSTATISTICSDEFS_H_

/*--------------------------------------STRUCTURE---------------------------------------*/

/*
 * The apStatistics_s data structure maintains statistics information of each fastpath
 * entry. And it also maintains rxDev and txDev info, so that it can be easily identified
 * on which interface (even virtual interface) the packets are flowing.
 * 
 * The total size is 24Bytes for Vx160 and Vx180.
 */

typedef struct apStatistics_s
{
        unsigned long   rxPkt;
        unsigned long   rxByte;
        unsigned long   txPkt;
        unsigned long   txByte;
        void            *rxDev;
        void            *txDev;
}apStatistics_t;

#endif //_APSTATISTICSDEFS_H_
